diff --git a/src/src/environment.c b/src/src/environment.c
index 9cb90c86f..06f804e69 100644
--- a/src/src/environment.c
+++ b/src/src/environment.c
@@ -5,6 +5,7 @@
 /* Copyright (c) Heiko Schlittermann 2016
  * hs@schlittermann.de
  * See the file NOTICE for conditions of use and distribution.
+ * SPDX-License-Identifier: GPL-2.0-only
  */
 
 #include "exim.h"
diff --git a/src/src/exim.c b/src/src/exim.c
index 3cd1d5f6d..62413e367 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 
 /* The main function: entry point, initialization, and high-level control.
diff --git a/src/src/exim.h b/src/src/exim.h
index 61642b5e7..24fedcced 100644
--- a/src/src/exim.h
+++ b/src/src/exim.h
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2021 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 
 /* Source files for exim all #include this header, which drags in everything
diff --git a/src/src/exim_dbmbuild.c b/src/src/exim_dbmbuild.c
index 5c046347b..bb04adc02 100644
--- a/src/src/exim_dbmbuild.c
+++ b/src/src/exim_dbmbuild.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 
 /* A small freestanding program to build dbm databases from serial input. For
diff --git a/src/src/exim_dbutil.c b/src/src/exim_dbutil.c
index 3824309b5..669f7098d 100644
--- a/src/src/exim_dbutil.c
+++ b/src/src/exim_dbutil.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 
 /* This single source file is used to compile three utility programs for
diff --git a/src/src/exim_lock.c b/src/src/exim_lock.c
index 427d22c1e..1a54a92ad 100644
--- a/src/src/exim_lock.c
+++ b/src/src/exim_lock.c
@@ -11,6 +11,7 @@ Default is -fcntl -lockfile.
 Argument: the name of the lock file
 
 Copyright (c) The Exim Maintainers 2016 - 2021
+SPDX-License-Identifier: GPL-2.0-only
 */
 
 #include "os.h"
diff --git a/src/src/expand.c b/src/src/expand.c
index ff0b4d600..050f01297 100644
--- a/src/src/expand.c
+++ b/src/src/expand.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 
 /* Functions for handling string expansion. */
diff --git a/src/src/filter.c b/src/src/filter.c
index cc4af230e..82a9122c6 100644
--- a/src/src/filter.c
+++ b/src/src/filter.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 
 /* Code for mail filtering functions. */
diff --git a/src/src/filtertest.c b/src/src/filtertest.c
index 87ebfb14f..8bab65e78 100644
--- a/src/src/filtertest.c
+++ b/src/src/filtertest.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2021 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2009 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 
 /* Code for the filter test function. */
diff --git a/src/src/functions.h b/src/src/functions.h
index d5164547a..be1fae00d 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 
 /* Prototypes for functions that appear in various modules. Gathered together
diff --git a/src/src/globals.c b/src/src/globals.c
index cafb15992..429952edc 100644
--- a/src/src/globals.c
+++ b/src/src/globals.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* All the global variables are defined together in this one module, so
 that they are easy to find. */
diff --git a/src/src/globals.h b/src/src/globals.h
index 1be96daec..48d93a1c3 100644
--- a/src/src/globals.h
+++ b/src/src/globals.h
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Almost all the global variables are defined together in this one header, so
 that they are easy to find. However, those that are visible during the
diff --git a/src/src/hash.c b/src/src/hash.c
index 51bcd4604..2b71463f1 100644
--- a/src/src/hash.c
+++ b/src/src/hash.c
@@ -3,6 +3,7 @@
  *
  *  Copyright (c) The Exim Maintainers 2010 - 2022
  *  Copyright (c) University of Cambridge 1995 - 2009
+ *  SPDX-License-Identifier: GPL-2.0-only
  *
  *  Hash interface functions
  */
diff --git a/src/src/hash.h b/src/src/hash.h
index 588325baf..c94e53129 100644
--- a/src/src/hash.h
+++ b/src/src/hash.h
@@ -1,6 +1,7 @@
 /*
  *  Exim - an Internet mail transport agent
  *  Copyright (c) The Exim Maintainers 1995 - 2022
+ *  SPDX-License-Identifier: GPL-2.0-only
  *
  *  Hash interface functions
  */
diff --git a/src/src/header.c b/src/src/header.c
index 7ef59ff53..2a8fbfe64 100644
--- a/src/src/header.c
+++ b/src/src/header.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2016 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 
 #include "exim.h"
diff --git a/src/src/hintsdb.h b/src/src/hintsdb.h
index b8e6744d6..e79e6bd49 100644
--- a/src/src/hintsdb.h
+++ b/src/src/hintsdb.h
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* This header file contains macro definitions so that a variety of DBM
 libraries can be used by Exim. Nigel Metheringham provided the original set for
diff --git a/src/src/hintsdb_structs.h b/src/src/hintsdb_structs.h
index e0670a10e..27cd9edf9 100644
--- a/src/src/hintsdb_structs.h
+++ b/src/src/hintsdb_structs.h
@@ -5,6 +5,7 @@
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* Copyright (c) The Exim Maintainers 2020 - 2021 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* This header file contains the definitions of the structures used in the
 various hints databases are also kept in this file, which is used by the
diff --git a/src/src/host.c b/src/src/host.c
index b6c2ea082..874e19a08 100644
--- a/src/src/host.c
+++ b/src/src/host.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Functions for finding hosts, either by gethostbyname(), gethostbyaddr(), or
 directly via the DNS. When IPv6 is supported, getipnodebyname() and
diff --git a/src/src/host_address.c b/src/src/host_address.c
index 9e6f958be..28a8a685f 100644
--- a/src/src/host_address.c
+++ b/src/src/host_address.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 #include "exim.h"
 
diff --git a/src/src/imap_utf7.c b/src/src/imap_utf7.c
index aac0fef6a..75ecb1a4b 100644
--- a/src/src/imap_utf7.c
+++ b/src/src/imap_utf7.c
@@ -1,5 +1,6 @@
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 #include "exim.h"
 
diff --git a/src/src/ip.c b/src/src/ip.c
index aa42343fb..2ac2b267d 100644
--- a/src/src/ip.c
+++ b/src/src/ip.c
@@ -5,6 +5,7 @@
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* Copyright (c) The Exim Maintainers 2020 - 2021 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Functions for doing things with sockets. With the advent of IPv6 this has
 got messier, so that it's worth pulling out the code into separate functions
diff --git a/src/src/local_scan.c b/src/src/local_scan.c
index 7a3bae7e3..85ecba8cb 100644
--- a/src/src/local_scan.c
+++ b/src/src/local_scan.c
@@ -5,6 +5,7 @@
 /* Copyright (c) University of Cambridge 1995 - 2009 */
 /* Copyright (c) The Exim Maintainers 2021 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 
 /******************************************************************************
diff --git a/src/src/local_scan.h b/src/src/local_scan.h
index c609a27e3..2eabc5929 100644
--- a/src/src/local_scan.h
+++ b/src/src/local_scan.h
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2020 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* This file is the header that is the only Exim header to be included in the
 source for the local_scan.c() function. It contains definitions that are made
diff --git a/src/src/log.c b/src/src/log.c
index a46d523db..f1d435ce4 100644
--- a/src/src/log.c
+++ b/src/src/log.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Functions for writing log files. The code for maintaining datestamped
 log files was originally contributed by Tony Sheen. */
diff --git a/src/src/lookupapi.h b/src/src/lookupapi.h
index 41cc239ce..cec8f976b 100644
--- a/src/src/lookupapi.h
+++ b/src/src/lookupapi.h
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2015 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 
 /* The "type" field in each item is a set of bit flags:
diff --git a/src/src/lookups/cdb.c b/src/src/lookups/cdb.c
index 966078f1a..696e52019 100644
--- a/src/src/lookups/cdb.c
+++ b/src/src/lookups/cdb.c
@@ -8,6 +8,7 @@
  *
  * Copyright (c) The Exim Maintainers 2020 - 2022
  * Copyright (c) 1998 Nigel Metheringham, Planet Online Ltd
+ * SPDX-License-Identifier: GPL-2.0-or-later
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
diff --git a/src/src/lookups/dbmdb.c b/src/src/lookups/dbmdb.c
index 32514afcc..c99e948b5 100644
--- a/src/src/lookups/dbmdb.c
+++ b/src/src/lookups/dbmdb.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 #include "../exim.h"
 #include "lf_functions.h"
diff --git a/src/src/lookups/dnsdb.c b/src/src/lookups/dnsdb.c
index 355be1b5d..4f43cf674 100644
--- a/src/src/lookups/dnsdb.c
+++ b/src/src/lookups/dnsdb.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 #include "../exim.h"
 #include "lf_functions.h"
diff --git a/src/src/lookups/dsearch.c b/src/src/lookups/dsearch.c
index a7691024a..6cae0dafb 100644
--- a/src/src/lookups/dsearch.c
+++ b/src/src/lookups/dsearch.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2015 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* The idea for this code came from Matthew Byng-Maddick, but his original has
 been heavily reworked a lot for Exim 4 (and it now uses stat() (more precisely:
diff --git a/src/src/lookups/ibase.c b/src/src/lookups/ibase.c
index c4fff71bd..d42e490c4 100644
--- a/src/src/lookups/ibase.c
+++ b/src/src/lookups/ibase.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* The code in this module was contributed by Ard Biesheuvel. */
 
diff --git a/src/src/lookups/json.c b/src/src/lookups/json.c
index c9abf8c4c..b1e5fb742 100644
--- a/src/src/lookups/json.c
+++ b/src/src/lookups/json.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2021 - 2022 */
 /* Copyright (c) Jeremy Harris 2019 - 2020 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 #include "../exim.h"
 #include "lf_functions.h"
diff --git a/src/src/lookups/ldap.c b/src/src/lookups/ldap.c
index 9751fa3b3..17c431e5c 100644
--- a/src/src/lookups/ldap.c
+++ b/src/src/lookups/ldap.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Many thanks to Stuart Lynne for contributing the original code for this
 driver. Further contributions from Michael Haardt, Brian Candler, Barry
diff --git a/src/src/lookups/ldap.h b/src/src/lookups/ldap.h
index ddfda8597..30228aebe 100644
--- a/src/src/lookups/ldap.h
+++ b/src/src/lookups/ldap.h
@@ -4,6 +4,7 @@
 
 /* Copyright (c) University of Cambridge 1995 - 2015 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Header for eldapauth_find */
 
diff --git a/src/src/lookups/lf_check_file.c b/src/src/lookups/lf_check_file.c
index 7f0f12806..1649f9f83 100644
--- a/src/src/lookups/lf_check_file.c
+++ b/src/src/lookups/lf_check_file.c
@@ -5,6 +5,7 @@
 /* Copyright (c) University of Cambridge 1995 - 2009 */
 /* Copyright (c) The Exim Maintainers 2020 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 
 #include "../exim.h"
diff --git a/src/src/lookups/lf_functions.h b/src/src/lookups/lf_functions.h
index fd9eb303a..b83b9652a 100644
--- a/src/src/lookups/lf_functions.h
+++ b/src/src/lookups/lf_functions.h
@@ -5,6 +5,7 @@
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* Copyright (c) The Exim Maintainers 2020 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Header for the functions that are shared by the lookups */
 
diff --git a/src/src/lookups/lf_quote.c b/src/src/lookups/lf_quote.c
index 6f4143d9f..816fe01e2 100644
--- a/src/src/lookups/lf_quote.c
+++ b/src/src/lookups/lf_quote.c
@@ -4,6 +4,7 @@
 
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 
 #include "../exim.h"
diff --git a/src/src/lookups/lf_sqlperform.c b/src/src/lookups/lf_sqlperform.c
index ce6f1635a..cf4b9cd0b 100644
--- a/src/src/lookups/lf_sqlperform.c
+++ b/src/src/lookups/lf_sqlperform.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 
 #include "../exim.h"
diff --git a/src/src/lookups/lmdb.c b/src/src/lookups/lmdb.c
index a32c7f7fb..ccfdbe453 100644
--- a/src/src/lookups/lmdb.c
+++ b/src/src/lookups/lmdb.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 2016 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 #include "../exim.h"
 
diff --git a/src/src/lookups/lsearch.c b/src/src/lookups/lsearch.c
index dcfdec91e..da73ae8bf 100644
--- a/src/src/lookups/lsearch.c
+++ b/src/src/lookups/lsearch.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 #include "../exim.h"
 #include "lf_functions.h"
diff --git a/src/src/lookups/mysql.c b/src/src/lookups/mysql.c
index 78b8c2b19..a8dae4ade 100644
--- a/src/src/lookups/mysql.c
+++ b/src/src/lookups/mysql.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Thanks to Paul Kelly for contributing the original code for these
 functions. */
diff --git a/src/src/lookups/nis.c b/src/src/lookups/nis.c
index 0024f44cf..e7c124757 100644
--- a/src/src/lookups/nis.c
+++ b/src/src/lookups/nis.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2015 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 #include "../exim.h"
 #include "lf_functions.h"
diff --git a/src/src/lookups/nisplus.c b/src/src/lookups/nisplus.c
index d9f3f7d83..78c79563f 100644
--- a/src/src/lookups/nisplus.c
+++ b/src/src/lookups/nisplus.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 #include "../exim.h"
 #include "lf_functions.h"
diff --git a/src/src/lookups/oracle.c b/src/src/lookups/oracle.c
index d32b5e44d..3f3868fe9 100644
--- a/src/src/lookups/oracle.c
+++ b/src/src/lookups/oracle.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2015 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Interface to an Oracle database. This code was originally supplied by
 Paul Kelly, but I have hacked it around for various reasons, and tried to add
diff --git a/src/src/lookups/passwd.c b/src/src/lookups/passwd.c
index eaf78b210..7df1a5aaf 100644
--- a/src/src/lookups/passwd.c
+++ b/src/src/lookups/passwd.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2015 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 #include "../exim.h"
 
diff --git a/src/src/lookups/pgsql.c b/src/src/lookups/pgsql.c
index 4bb693ad1..4fcd0e3ed 100644
--- a/src/src/lookups/pgsql.c
+++ b/src/src/lookups/pgsql.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Thanks to Petr Cech for contributing the original code for these
 functions. Thanks to Joachim Wieland for the initial patch for the Unix domain
diff --git a/src/src/lookups/readsock.c b/src/src/lookups/readsock.c
index 22179c91c..7c7b9cfa8 100644
--- a/src/src/lookups/readsock.c
+++ b/src/src/lookups/readsock.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2021 - 2022 */
 /* Copyright (c) Jeremy Harris 2020 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 #include "../exim.h"
 #include "lf_functions.h"
diff --git a/src/src/lookups/redis.c b/src/src/lookups/redis.c
index 9c8559c1e..c7fcb66f0 100644
--- a/src/src/lookups/redis.c
+++ b/src/src/lookups/redis.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 #include "../exim.h"
 
diff --git a/src/src/lookups/spf.c b/src/src/lookups/spf.c
index 78d954c8c..a1052d7fc 100644
--- a/src/src/lookups/spf.c
+++ b/src/src/lookups/spf.c
@@ -7,6 +7,7 @@
 
 Copyright (c) The Exim Maintainers 2020 - 2022
 Copyright (c) 2005 Chris Webb, Arachsys Internet Services Ltd
+SPDX-License-Identifier: GPL-2.0-or-later
 
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
diff --git a/src/src/lookups/sqlite.c b/src/src/lookups/sqlite.c
index 9080ae702..b9a735e18 100644
--- a/src/src/lookups/sqlite.c
+++ b/src/src/lookups/sqlite.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 #include "../exim.h"
 #include "lf_functions.h"
diff --git a/src/src/lookups/testdb.c b/src/src/lookups/testdb.c
index 48241615f..f94150b68 100644
--- a/src/src/lookups/testdb.c
+++ b/src/src/lookups/testdb.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2015 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 #include "../exim.h"
 #include "lf_functions.h"
diff --git a/src/src/lookups/whoson.c b/src/src/lookups/whoson.c
index 990703fd0..cd236787e 100644
--- a/src/src/lookups/whoson.c
+++ b/src/src/lookups/whoson.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2015 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* This code originally came from Robert Wal. */
 
diff --git a/src/src/lss.c b/src/src/lss.c
index 167522d2f..0d20c07b6 100644
--- a/src/src/lss.c
+++ b/src/src/lss.c
@@ -4,6 +4,7 @@
 
 /* Copyright (c) University of Cambridge 1995 - 2015 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Support functions for calling from local_scan(). These are mostly just
 wrappers for various internal functions. */
diff --git a/src/src/macro_predef.c b/src/src/macro_predef.c
index a0c659c9f..fe814500d 100644
--- a/src/src/macro_predef.c
+++ b/src/src/macro_predef.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) Jeremy Harris 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Create a static data structure with the predefined macros, to be
 included in the main Exim build */
diff --git a/src/src/macro_predef.h b/src/src/macro_predef.h
index 59b1bbe3b..d3bc5c074 100644
--- a/src/src/macro_predef.h
+++ b/src/src/macro_predef.h
@@ -5,6 +5,7 @@
 /* Copyright (c) Jeremy Harris 2017 - 2018 */
 /* Copyright (c) The Exim Maintainers 2021 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Global functions */
 
diff --git a/src/src/macros.h b/src/src/macros.h
index adbe6a267..db1c34b65 100644
--- a/src/src/macros.h
+++ b/src/src/macros.h
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 
 /* These two macros make it possible to obtain the result of macro-expanding
diff --git a/src/src/malware.c b/src/src/malware.c
index 01dd455ba..96514e276 100644
--- a/src/src/malware.c
+++ b/src/src/malware.c
@@ -6,6 +6,7 @@
  * Copyright (c) The Exim Maintainers 2015 - 2022
  * Copyright (c) Tom Kistner <tom@duncanthrax.net> 2003 - 2015
  * License: GPL
+ * SPDX-License-Identifier: GPL-2.0-only
  */
 
 /* Code for calling virus (malware) scanners. Called from acl.c. */
diff --git a/src/src/match.c b/src/src/match.c
index b4a0352ee..a877aef3b 100644
--- a/src/src/match.c
+++ b/src/src/match.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Functions for matching strings */
 
diff --git a/src/src/md5.c b/src/src/md5.c
index fdb144e67..e6df32c7a 100644
--- a/src/src/md5.c
+++ b/src/src/md5.c
@@ -5,6 +5,7 @@
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* Copyright (c) The Exim Maintainers 2020 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 #ifndef STAND_ALONE
 #include "exim.h"
diff --git a/src/src/mime.c b/src/src/mime.c
index c1921992e..bebe9bf44 100644
--- a/src/src/mime.c
+++ b/src/src/mime.c
@@ -6,6 +6,7 @@
  * Copyright (c) The Exim Maintainers 2015 - 2022
  * Copyright (c) Tom Kistner <tom@duncanthrax.net> 2004 - 2015
  * License: GPL
+ * SPDX-License-Identifier: GPL-2.0-only
  */
 
 #include "exim.h"
diff --git a/src/src/mime.h b/src/src/mime.h
index 5fd4392d5..48bbd81de 100644
--- a/src/src/mime.h
+++ b/src/src/mime.h
@@ -5,6 +5,7 @@
 /* Copyright (c) Tom Kistner <tom@duncanthrax.net> 2004, 2015
  * License: GPL
  * Copyright (c) The Exim Maintainers 2016
+ * SPDX-License-Identifier: GPL-2.0-only
  */
 
 #ifdef WITH_CONTENT_SCAN
diff --git a/src/src/moan.c b/src/src/moan.c
index 4f2550d82..387359458 100644
--- a/src/src/moan.c
+++ b/src/src/moan.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Functions for sending messages to sender or to mailmaster. */
 
diff --git a/src/src/mytypes.h b/src/src/mytypes.h
index 141d2c613..06426af7a 100644
--- a/src/src/mytypes.h
+++ b/src/src/mytypes.h
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 
 /* This header file contains type definitions and macros that I use as
diff --git a/src/src/os.c b/src/src/os.c
index ac5f61b65..4edb2ca98 100644
--- a/src/src/os.c
+++ b/src/src/os.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2021 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 #ifdef STAND_ALONE
 # include <signal.h>
diff --git a/src/src/osfunctions.h b/src/src/osfunctions.h
index 547cf1379..454e9f77f 100644
--- a/src/src/osfunctions.h
+++ b/src/src/osfunctions.h
@@ -5,6 +5,7 @@
 /* Copyright (c) University of Cambridge 1995 - 2016 */
 /* Copyright (c) The Exim Maintainers 2020 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Prototypes for os-specific functions. For utilities, we don't need the one
 that uses a type that isn't defined for them. */
diff --git a/src/src/parse.c b/src/src/parse.c
index bdba3ecd0..93b12bc77 100644
--- a/src/src/parse.c
+++ b/src/src/parse.c
@@ -5,6 +5,7 @@
 /* Copyright (c) The Exim Maintainers 2020 - 2022 */
 /* Copyright (c) University of Cambridge 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Functions for parsing addresses */
 
diff --git a/src/src/pdkim/crypt_ver.h b/src/src/pdkim/crypt_ver.h
index a6d7e36af..367527e39 100644
--- a/src/src/pdkim/crypt_ver.h
+++ b/src/src/pdkim/crypt_ver.h
@@ -4,6 +4,7 @@
 
 /* Copyright (c) Jeremy Harris 1995 - 2018 */
 /* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Signing and hashing routine selection for PDKIM */
 
diff --git a/src/src/pdkim/pdkim.c b/src/src/pdkim/pdkim.c
index e47bfc505..eb26b3864 100644
--- a/src/src/pdkim/pdkim.c
+++ b/src/src/pdkim/pdkim.c
@@ -4,6 +4,7 @@
  *  Copyright (c) The Exim Maintainers 2021 - 2022
  *  Copyright (C) 2009 - 2016  Tom Kistner <tom@duncanthrax.net>
  *  Copyright (C) 2016 - 2020  Jeremy Harris <jgh@exim.org>
+ *  SPDX-License-Identifier: GPL-2.0-or-later
  *
  *  http://duncanthrax.net/pdkim/
  *
diff --git a/src/src/pdkim/pdkim.h b/src/src/pdkim/pdkim.h
index f6ff78251..f918938e8 100644
--- a/src/src/pdkim/pdkim.h
+++ b/src/src/pdkim/pdkim.h
@@ -3,6 +3,7 @@
  *
  *  Copyright (C) 2009 - 2012  Tom Kistner <tom@duncanthrax.net>
  *  Copyright (c) 2016 - 2020  Jeremy Harris
+ *  SPDX-License-Identifier: GPL-2.0-or-later
  *
  *  http://duncanthrax.net/pdkim/
  *
diff --git a/src/src/pdkim/pdkim_hash.h b/src/src/pdkim/pdkim_hash.h
index 8f9a12628..e470299a4 100644
--- a/src/src/pdkim/pdkim_hash.h
+++ b/src/src/pdkim/pdkim_hash.h
@@ -2,6 +2,7 @@
  *  PDKIM - a RFC4871 (DKIM) implementation
  *
  *  Copyright (C) 1995 - 2018  Exim maintainers
+ *  SPDX-License-Identifier: GPL-2.0-only
  *
  *  Hash interface functions
  */
diff --git a/src/src/pdkim/signing.c b/src/src/pdkim/signing.c
index d78f31acf..8876f617c 100644
--- a/src/src/pdkim/signing.c
+++ b/src/src/pdkim/signing.c
@@ -1,6 +1,7 @@
 /*
  *  PDKIM - a RFC4871 (DKIM) implementation
  *  Copyright (c) The Exim Maintainers 1995 - 2022
+ *  SPDX-License-Identifier: GPL-2.0-only
  *
  *  signing/verification interface
  */
diff --git a/src/src/pdkim/signing.h b/src/src/pdkim/signing.h
index ed6f397ce..880342b6f 100644
--- a/src/src/pdkim/signing.h
+++ b/src/src/pdkim/signing.h
@@ -2,6 +2,7 @@
  *  PDKIM - a RFC4871 (DKIM) implementation
  *
  *  Copyright (C) 1995 - 2020  Exim maintainers
+ *  SPDX-License-Identifier: GPL-2.0-only
  *
  *  RSA signing/verification interface
  */
diff --git a/src/src/perl.c b/src/src/perl.c
index f07ee2e27..b5c3f882e 100644
--- a/src/src/perl.c
+++ b/src/src/perl.c
@@ -4,6 +4,7 @@
 
 /* Copyright (c) The Exim Maintainers 1999 - 2022 */
 /* Copyright (c) 1998 Malcolm Beattie */
+/* SPDX-License-Identifier: GPL-2.0-only */
 
 /* Modified by PH to get rid of the "na" usage, March 1999.
    Modified further by PH for general tidying for Exim 4.
diff --git a/src/src/priv.c b/src/src/priv.c
index 94d425401..c818b5b78 100644
--- a/src/src/priv.c
+++ b/src/src/priv.c
@@ -1,3 +1,6 @@
+/* Copyright (c)  The Exim Maintainers 2022 *
+/* SPDX-License-Identifier: GPL-2.0-only */
+
 #include "exim.h"
 #include <sys/types.h>
 #include <unistd.h>
